using System;

namespace Westwind.Windows
{
		/// <summary>
		/// Summary description for IwwData.
		/// </summary>
		public interface IwwDataControl
		{
		/// <summary>
		/// The object that the control is bound to. This is the base object
		/// and you are still required to set the ControlSource property with
		/// the property to bind to
		/// </summary>
		string ControlSourceObject
		{ 
			get; set; 
		}

		/// <summary>
		/// The ControlSource property to bind to set as a string. Uses Reflection to retrieve and set 
		/// content of the object in question
		/// </summary>
		string ControlSourceProperty  
		{
			get; set;
		}
		

		/// <summary>
		/// Field or type that this control is bound to
		/// </summary>
		string BindingProperty
		{
			get; set;
		}

		/// <summary>
		/// Hooks up databinding for all child controls that support it. Will loop through all child containtainers.
		/// Implementation can simlpe call Westwind.Windows.wwDataControlHelper.FormBindData(loParent)
		/// </summary>
		/// <param name="loContainer">Form or container object to start parsing from</param>
		void BindData(object loParent) ;
	}
}
