#INCLUDE wwhelp.h
SET PROCEDURE TO AddinManager ADDITIVE


*************************************************************
DEFINE CLASS AddInManager AS Custom
*************************************************************
*: Author: Rick Strahl
*:         (c) West Wind Technologies, 2005
*:Contact: http://www.west-wind.com
*:Created: 04/07/2005
*************************************************************
#IF .F.
*:Help Documentation
*:Topic:
Class AddInManager

*:Description:

*:Example:

*:Remarks:

*:SeeAlso:


*:ENDHELP
#ENDIF

cFileName = "addins.dbf"
oAddIns = .null.

cErrorMsg = ""
lError = ""

************************************************************************
* AddinManager :: Open
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION Open()

IF FILE(this.cFileName)
   IF USED("addins")
      SELECT AddIns
   ELSE
      USE Addins IN 0 ALIAS addins
      SELECT Addins
   ENDIF
ELSE
   *** Create Addins file
   SELECT 0
   CREATE  TABLE (this.cFileName) ;
   (    PK          C (10),;
   NAME        C (80),;
   DESCRIPT    C (254),;
   TYPE        C (10),;
   FILENAME    C (254),;
   OBJNAME     C (80),;
   OBJMETHOD   C (80) )
   USE
      
   RETURN .F.   
ENDIF

RETURN .T.
ENDFUNC
*  AddinManager :: Open

************************************************************************
* AddinManager :: LoadAddIns
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION LoadAddIns()

LOCAL loAddins as Collection

THIS.oAddins = CREATEOBJECT("Collection")
loAddins = this.oAddins

IF !THIS.Open()
   RETURN .F.
ENDIF

*** Pop into array
SCAN
   IF EMPTY(PK) OR EMPTY(Name)
      DELETE 
      LOOP
   ENDIF
   SCATTER NAME loAddin MEMO
   loAddins.Add(loAddin,loAddin.Pk)
ENDSCAN

USE IN Addins

ENDFUNC

************************************************************************
* AddinManager :: ActivateAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION ActivateAddin(lcPk)
LOCAL llError, loAddin

loAddIn = this.GetAddin(lcPk)
IF ISNULL(loAddin)
   RETURN .F.
ENDIF

IF loAddin.Type # "COM" AND !FILE(loAddin.Filename)
   this.SetError("Addin file does not exist: " + loAddin.Filename)
   RETURN .F.
ENDIF

DO CASE
   CASE loAddin.Type = "FOX"
      RETURN this.ActivateFoxAddin(loAddin)
   CASE loAddin.Type = ".NET"
      RETURN this.ActivateNetAddin(loAddin)
   CASE loAddin.Type = "COM"
      RETURN THIS.ActivateCOMAddin(loAddin)
   CASE loAddin.Type = "EXE"      
ENDCASE

RETURN .T.
ENDFUNC
*  AddinManager :: ActivateAddin


************************************************************************
* AddinManager :: ActivateFoxAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
PROTECTED FUNCTION ActivateFoxAddin(loAddin)
LOCAL loException, llError

llError = .f.

lcFileName = LOWER(TRIM(loAddin.FileName))
DO CASE
  CASE JUSTEXT(lcFileName) = "prg" 
      llNeedToCompile = .T.
      TRY
         *** This catches both fxp file not existing and being out of date
         *** Slightly more efficient than checking file, and the dates
         llNeedToCompile = FDATE(lcFilename,1) > FDATE(FORCEEXT(lcFileName,"fxp"),1)
      CATCH
         llNeedToCompile = .t.
      ENDTRY

      IF llNeedToCompile
         TRY
      *** /// RAS Modified  04/07/2005  
      *** this needs compiler checks so we don't recompile unless we have to
            COMPILE (lcFileName)
         CATCH TO loException
            llError = .t.
         ENDTRY
         IF llError 
            this.SetError("Error compiling PRG file:" + CRLF +;
                          loException.Message)
            RETURN .f.
         ENDIF
      ENDIF
      
      TRY
         loObject = NEWOBJECT(TRIM(loAddin.ObjName),lcFileName)
         lcAddinMethod = "loObject." + TRIM(loAddIn.ObjMethod) + "(goHelp)"
         llResult = EVALUATE( lcAddinMethod )
      CATCH TO loException
         llError = .t.
      ENDTRY
      IF llError
         THIS.SetError("Error executing addin method: " + lcAddinMethod + CRLF  +;
                      loException.Message)
         RETURN .F.                      
      ENDIF
      
      RETURN .T.

  CASE JUSTEXT(lcFileName) = "exe" OR JUSTEXT(lcFilename) =  "app"
      LOCAL lcAddinMethod
      lcAddinMethod = ""
      TRY
         *** Load the libraries
         DO (lcFileName)
         
         loObject = NEWOBJECT(TRIM(loAddin.ObjName),lcFileName)
         lcAddinMethod = "loObject." + TRIM(loAddIn.ObjMethod) + "(goHelp)"
         llResult = EVALUATE( lcAddinMethod )
      CATCH TO loException
         llError = .t.
      ENDTRY
      IF llError
         THIS.SetError("Error executing addin method: " + lcAddinMethod + CRLF  +;
                      loException.Message)
         RETURN .F.                      
      ENDIF
      
      RETURN .T.
ENDCASE

THIS.SetError("Unsupported file format for a FoxPro addin")
RETURN .F.
ENDFUNC
*  AddinManager :: ActivateFoxAddin

************************************************************************
* AddinManager :: ActivateNetAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION ActivateNetAddin(loAddin)

lcFileName = LOWER(TRIM(loAddin.FileName))

*** Make sure COM object exists
IF !ISCOMOBJECT("wwReflection.AddinFactory")
   lcError = ""
   DotNetTypeParserCheck(lcError,.T.) && Force Registration

   IF !ISCOMOBJECT("wwReflection.AddinFactory")
      THIS.SetError("Unable to register Interop Assembly." + CHR(13) + CHR(10)+;
                    lcError)
      RETURN .F.
   ENDIF
ENDIF

LOCAL aiFactory as wwReflection.AddinFactory

LOCAL ai as wwReflection.AddinExecution

#IF .F.   && Direct Execution
   ai = CREATEOBJECT("wwReflection.AddinExecution")
   Result = ai.Execute(TRIM(loAddin.Filename),TRIM(loAddin.ObjName),;
                    TRIM(loAddin.ObjMethod),goHelp)
#ELSE    && Execute in seperate AppDomain
   aiFactory = CREATEOBJECT("wwReflection.AddinFactory")
   ai = aiFactory.CreateAddin()
   Result = ai.Execute(TRIM(loAddin.Filename),TRIM(loAddin.ObjName),;
                       TRIM(loAddin.ObjMethod),goHelp)
#ENDIF
                    
IF !Result
   this.SetError(ai.ErrorMessage)
   aiFactory.UnloadAddin()
   RETURN .f.
ENDIF
   
aiFactory.UnloadAddin()
                       
RETURN .t.                    
ENDFUNC
*  AddinManager :: ActivateNetAddin

************************************************************************
* AddinManager :: ActivateCOMAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION ActivateCOMAddin(loAddin)
LOCAL llError, lcProgId, loException

lcProgId = TRIM(loAddin.objName)
llError = .f.
loException = null

llResult = .f.
TRY 
   loObject = CREATEOBJECT(lcProgId)
   llResult = EVALUATE("loObject." + TRIM(loAddin.objMethod) + "(goHelp)")
CATCH TO loException
   llError = .T.
   this.SetError(loException.Message)
ENDTRY   

IF llError
   RETURN .f.
ENDIF

RETURN llResult                    
ENDFUNC
*  AddinManager :: ActivateNetAddin


************************************************************************
* AddinManager :: CreateAddinConfig
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION CreateAddinConfig(lcPk)

loAddin = this.GetAddin(lcPk)
IF ISNULL(loAddin)
   RETURN .f.
ENDIF

*** Save the filename
lcFullFileName = loAddin.FileName

loAddin.FileName = JUSTFNAME(lcFullFileName)

LOCAL loXML as wwXML
loXML = CREATEOBJECT("wwXML")
loXML.cPropertyExclusionList  = "" 
loXML.cDocrootname = "helpbuilder"
lcXML = loXML.ObjectToXML(loAddin,"addin")

STRTOFILE(lcXML,FORCEEXT( lcFullFileName, "hbaddin") )

*** Restore the full path
loAddin.FileName = lcFullFileName

RETURN .T.
ENDFUNC
*  AddinManager :: CreateAddinConfig

************************************************************************
* AddinManager :: LoadFromAddinConfig
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION LoadFromAddinConfig(lcFileName)
LOCAL llError,lcXML
llError = .f.

lcXML = ""

TRY
   lcXML = FILETOSTR(lcFileName)
CATCH
   llError = .t.
   this.SetError("Can't find add-in configuration file")
ENDTRY

IF llError
   RETURN .F.
ENDIF

LOCAL loAdmin
loAddin = this.NewAddin()
lcPk = loAddin.Pk

LOCAL loXML as wwxml
loXML = CREATEOBJECT("wwXML")
loXML.cPropertyExclusionList  = "" 

loAddin = loXML.XmlToObject(lcXML,loAddin)
IF loXML.lError
   this.oAddins.Remove(lcPK)
   this.SetError(loXML.cErrorMsg)
   RETURN .F.
ENDIF

IF llError
   this.oAddins.Remove(lcPK)
   this.SetError("Add-in exists already.")
   RETURN .F.
ENDIF

loAddin.FileName = LOWER(JUSTPATH(lcFileName) + "\" + loAddin.FileName)

*** Write to disk
this.SaveAddins()

*** Have to reload to update Indexes
this.LoadAddins()

RETURN .T.
ENDFUNC
*  AddinManager :: LoadFromAddinConfig


************************************************************************
* AddinManager :: AddToMenu
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION AddToMenu(loBand)

loBand.Tools.RemoveAll()


lnCount = 0
FOR EACH loAddIn IN this.oAddIns
   lnCount = lnCount + 1
   loTool = loBand.Tools.Add(lnCount,"AddIns_" + TRIM(loAddin.Pk))
   loTool.Caption = TRIM(loAddin.name)
ENDFOR

IF lnCount = 0
   RETURN .F.
ENDIF

ENDFUNC
*  AddinManager :: AddToMenu

************************************************************************
* AddinManager :: GetAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION GetAddin(lvPk)
LOCAL loAddin, llError

IF ISNULL(THIS.oAddins )
   this.LoadAddins()
ENDIF

llError = .f.
loAddin = null
TRY
   loAddin = this.oAddins.Item(lvPk)
CATCH
   THIS.SetError("Invalid Addin Id")
   llError = .t.
ENDTRY 

RETURN loAddin
ENDFUNC
*  AddinManager :: GetAddin


************************************************************************
* AddinManager :: NewAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION NewAddin()
LOCAL loAddin

IF !THIS.Open()
   RETURN null
ENDIF

SCATTER NAME loAddin BLANK MEMO
loAddin.Pk = SYS(2015)
loAddin.Type = ".NET"

this.oAddins.Add(loAddin,loAddin.Pk)

USE IN Addins

RETURN loAddin
ENDFUNC
*  AddinManager :: NewAddin

************************************************************************
* AddinManager :: SaveAddins
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION SaveAddins()
LOCAL loAddin, lnX

IF !THIS.Open()
   RETURN .F.
ENDIF

SELECT ADDINS

*** Walk backwards in case we have to delete empties
FOR lnX = this.oAddins.Count TO 1 STEP -1 
   loAddin = this.oAddins[lnx]

   IF EMPTY(loAddin.Pk) 
      LOOP
   ENDIF
   
   IF EMPTY(loAddin.Name)
      this.oAddins.Remove[lnX]
      LOOP
   ENDIF

   LOCATE FOR PK = loAddin.Pk
   IF FOUND()
      GATHER NAME loAddin MEMO
   ELSE
      APPEND BLANK
      GATHER NAME loAddin MEMO
   ENDIF   
ENDFOR

USE IN ADDINS
RETURN .T.
ENDFUNC
*  AddinManager :: SaveAddins

************************************************************************
* AddinManager :: DeleteAddin
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
FUNCTION DeleteAddin(lcID)
LOCAL loAddin, llError

llError = .f.
loAddin = null
TRY
   loAddin = this.oAddins.Item(lcID)
CATCH
   THIS.SetError("Invalid Addin Id")
   llError = .t.
ENDTRY 

IF llError
   RETURN .f.
ENDIF

lcPk = loAddin.PK

this.oAddins.Remove(lcId)

IF !THIS.Open()
   RETURN .F.
ENDIF

DELETE FOR PK = lcPK

USE IN ADDIns
RETURN .T.
ENDFUNC
*  AddinManager :: DeleteAddin

************************************************************************
* AddinManager :: SetError
****************************************
***  Function:
***    Assume:
***      Pass:
***    Return:
************************************************************************
PROTECTED FUNCTION SetError
LPARAMETERS lcError

IF EMPTY(lcError)
  THIS.cErrormsg = ""
  THIS.lError = .F.
  RETURN
ENDIF

THIS.lError = .T.
THIS.cErrorMsg = lcError 
ENDFUNC
*  AddinManager :: SetError

ENDDEFINE
*EOC AddInManager 