using System;
using System.Runtime.InteropServices;

namespace Westwind.wwReflection
{

	[ClassInterface(ClassInterfaceType.AutoDual)]
	[ProgId("wwReflection.ObjectMethod")]
	[Serializable]
	public class ObjectMethod 
	{
		public string cName = "";
		public string cParameters = "";
		public string cRawParameters = "";
		public string cDescriptiveParameters = "";
		public string cReturnType = "";
		public string cScope = "";
		
		public bool bStatic = false;
		public bool bLiteral = false;
		public string cOther = "";

		public string[] aParameters = null;
		public int nParameterCount = 0;

		// *** Parsed from XMLDocs
		public string cHelpText = "";
		public string cRemarks = "";
		public string cExample = "";
		public string cSeeAlso = "";

		public string cSignature = "";
		public string cDeclaringType = "";

	}

	[ClassInterface(ClassInterfaceType.AutoDual)]
	[ProgId("wwReflection.ObjectProperty")]
	[Serializable]
	public class ObjectProperty
	{
		public string cName = "";
		public string cType = "";
        		
		public string cScope = "";
		public string cAccessType = "";
		public string cDefaultValue = "";

		public bool bStatic = false;
		public bool bReadOnly = false;
		public bool bLiteral = false;

		public string cOther = "";
		
		/// Field or Property
		public string cFieldOrProperty = "";

		// *** Parsed from XML docs
		public string cHelpText = "";
		public string cRemarks = "";
		public string cExample = "";
		public string cSeeAlso = "";

		public string cSignature = "";
		public string cDeclaringType = "";
	}

	[Serializable]
	public class ObjectEvent 
	{
		public string cName = "";
		public string cType = "";
        		
		public string cScope = "";
		public bool bStatic = false;
		public bool bReadOnly = false;

		public string cOther = "";
		
		public string cHelpText = "";
		public string cRemarks = "";
		public string cExample = "";
		public string cSeeAlso = "";

		public string cSignature = "";
		public string cDeclaringType = "";
	}

}
