*&* TEST_LOG4FOX.PRG
*&* a silly test program designed to show some of the
*&* capabilities of LOG4FOX
*&* (c) Lisa Slater Nicholls

#INCLUDE LOG4FOX.H

LPARAMETERS iHandle

LOCAL lcD, llOpenedHandle, liSelect, loLogger

lcD = SET("DIRECTORY")
liSelect = SELECT()

CD (JUSTPATH(SYS(16,0)))

IF EMPTY(iHandle)
   MESSAGEBOX("In the next dialog, connect to a database " + CHR(13) + ;
              "with an EventLog table, " + CHR(13) +;
              "if you have one... " + CHR(13) + CHR(13) + ;
              "If you don't, that's okay... ",64,"Log4Fox: Add a SQL Log?")
   iHandle = SQLCONNECT()
   IF iHandle < 1
      iHandle = .F.
   ENDIF
   IF NOT EMPTY(iHandle)
       llOpenedHandle = .T.
   ENDIF
ENDIF

IF NOT EMPTY(iHandle)
   SELECT 0
   IF SQLCOLUMNS(iHandle,"EVENTLOG","FOXPRO","dummy") < 0
      IF llOpenedHandle
         SQLDISCONNECT(iHandle)
         llOpenedHandle = .F.
      ENDIF
      iHandle = .F.
   ELSE
      INDEX ON UPPER(Field_Name) TAG Dummy
      IF NOT (SEEK("LOGGER") AND SEEK("CREATE_DATE") AND SEEK("LOG_EVENTS"))
         IF llOpenedHandle
            SQLDISCONNECT(iHandle)
            llOpenedHandle = .F.
         ENDIF
         iHandle = .F.
      ENDIF
   ENDIF
   IF EMPTY(iHandle)
      MESSAGEBOX("Could not find a suitable EventLog table in your database.",48,;
       "Log4Fox: Not doing SQL Logging!")
   ENDIF       
   IF USED("Dummy")
      USE IN Dummy
   ENDIF      
ENDIF    

IF EMPTY(iHandle)
   MESSAGEBOX("Continuing without a database for SQL logging." + ;
              CHR(13) + CHR(13) + ;
             "Please see the notes in LOG4FOX.PRG for the EventLog table structure, " + CHR(13) + ;
             "If you would like to use it in future tests.")
ELSE
   MESSAGEBOX("Continuing with SQL logging, handle: " + TRANSFORM(iHandle) + "." )
ENDIF

*&* create a config cursor:
SELECT 0
CREATE CURSOR x (loglevel i, logger c(50), logappend l, logname c(20))
INSERT INTO x VALUES (LOGLEVEL_INFO,"",.T.,"")
INSERT INTO x VALUES (LOGLEVEL_DEBUG,"log4foxSQLAppender",.T.,"testlogger")  && cannot be instantiated from the init, but does know about config
INSERT INTO x VALUES (LOGLEVEL_ALL,"log4foxConsoleAppender",.F., "") && doesn't know about config, but can receive global values
INSERT INTO x VALUES (0,"log4foxFileAppender",.F., "") && also doesn't know about config, can be instantiated though
INSERT INTO x VALUES (LOGLEVEL_ALL,"log4foxMessageBoxAppender",.F. , "") && ditto
SELECT (liSelect)
SET PROCEDURE TO LOG4FOX ADDITIVE && will do for this test

*&* Now instance a log4fox derived class that understands a cursor for configuration.
*&* We will not require an owner object for log4fox's main object for this test:
loLogger = CREATEOBJECT("log4foxConfigAlias",NULL,.T.,"x") 
*&* but ordinarily this object would belong to an owner, like so:
*&* loLogger = CREATEOBJECT("log4foxconfigalias",THIS.Application,.F.,"x") 

ACTIVATE SCREEN
CLEAR
? "Note: what you see on _SCREEN is not an appender, it's output from the test program... "
?
? "Number of appenders on init, as Log4FoxConfigAlias reads its config records: ", TRANSFORM(loLogger.Appenders.COUNT)
? "All existing appender(s) have log level set by header record when you speciy the config cursor: ", ;
   TRANSFORM(loLogger.Appenders(1).getLogLevel()) 
   
IF NOT EMPTY(iHandle)
   CREATEOBJECT("log4foxSQLAppender",loLogger,,iHandle) && creates another listener
   ? "Number of appenders after explicitly adding SQL appender: ", TRANSFORM(loLogger.Appenders.COUNT)
   ? "The SQL log level is still set at its internal default: ", TRANSFORM(loLogger.Appenders(4).getLogLevel()) && will still be global one
ENDIF
loLogger.OPEN()
? "File appender logname is: " + loLogger.Appenders(2).GetLogFileName() && its generated default
IF NOT EMPTY(iHandle)
   ? "After log open event, SQL Appender has read its own config record. Its log level is now set by its own config table record: ", TRANSFORM(loLogger.Appenders(4).getLogLevel()) && should have read its own config value(s)
   ? "SQL Appender also learned that it should *append*, not overwrite, from its config record."
   loLogger.Appenders(4).SetLogLevel(LOGLEVEL_ALL)
   ? "After explicit setting, SQL Appender log level is now set at LOGLEVEL_ALL... "      
   ? "... note: Because the log is open, this event will be logged automatically at LOGLEVEL_INFO level: " , TRANSFORM(loLogger.Appenders(4).getLogLevel())
ENDIF
loLogger.LOG("This is a test at level LOGLEVEL_DEBUG", LOGLEVEL_DEBUG)
loLogger.LOG("This is a test at level LOGLEVEL_ALL",LOGLEVEL_ALL)
loLogger.LOG("This is a test at level LOGLEVEL_INFO", LOGLEVEL_INFO)
loLogger.LOG("This is a test at level LOGLEVEL_FATAL", LOGLEVEL_FATAL)
loLogger.LOG("This is a test at level LOGLEVEL_WARN", LOGLEVEL_WARN)
loLogger.LOG("This is a test at level LOGLEVEL_ERROR", LOGLEVEL_ERROR)
loLogger.LOG("This test shows the log event parameter for those appenders formatted to show it.",LOGLEVEL_INFO,"TestEvent")
loLogger.CLOSE()

MODIFY FILE (loLogger.Appenders(2).GetLogFileName()) NOWAIT

IF NOT EMPTY (iHandle)
   IF SQLEXEC(iHandle,"SELECT * FROM EventLog WHERE logger = 'testlogger'","eventlog") > 0
      MODIFY MEMO log_events NOWAIT
   ENDIF
ENDIF
IF llOpenedHandle
   SQLDISCONNECT(iHandle)
ENDIF   

CD (lcD)
SELECT (liSelect)

RETURN

